/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.coordinate.model;

import com.google.api.client.json.GenericJson;
import com.google.api.client.json.JsonString;

/**
 * Custom field definition.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Maps Coordinate API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class CustomFieldDef extends GenericJson {

  /**
   * Whether the field is enabled.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean enabled;

  /**
   * Custom field id.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @JsonString
  private Long id;

  /**
   * Identifies this object as a custom field definition.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * Custom field name.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String name;

  /**
   * Whether the field is required for checkout.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean requiredForCheckout;

  /**
   * Custom field type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String type;

  /**
   * Whether the field is enabled.
   * The value returned may be {@code null}.
   */
  public Boolean getEnabled() {
    return enabled;
  }

  /**
   * Whether the field is enabled.
   * The value set may be {@code null}.
   */
  public CustomFieldDef setEnabled(Boolean enabled) {
    this.enabled = enabled;
    return this;
  }

  /**
   * Custom field id.
   * The value returned may be {@code null}.
   */
  public Long getId() {
    return id;
  }

  /**
   * Custom field id.
   * The value set may be {@code null}.
   */
  public CustomFieldDef setId(Long id) {
    this.id = id;
    return this;
  }

  /**
   * Identifies this object as a custom field definition.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Identifies this object as a custom field definition.
   * The value set may be {@code null}.
   */
  public CustomFieldDef setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Custom field name.
   * The value returned may be {@code null}.
   */
  public String getName() {
    return name;
  }

  /**
   * Custom field name.
   * The value set may be {@code null}.
   */
  public CustomFieldDef setName(String name) {
    this.name = name;
    return this;
  }

  /**
   * Whether the field is required for checkout.
   * The value returned may be {@code null}.
   */
  public Boolean getRequiredForCheckout() {
    return requiredForCheckout;
  }

  /**
   * Whether the field is required for checkout.
   * The value set may be {@code null}.
   */
  public CustomFieldDef setRequiredForCheckout(Boolean requiredForCheckout) {
    this.requiredForCheckout = requiredForCheckout;
    return this;
  }

  /**
   * Custom field type.
   * The value returned may be {@code null}.
   */
  public String getType() {
    return type;
  }

  /**
   * Custom field type.
   * The value set may be {@code null}.
   */
  public CustomFieldDef setType(String type) {
    this.type = type;
    return this;
  }

}
