/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.coordinate.model;

import com.google.api.client.json.GenericJson;
import com.google.api.client.json.JsonString;

/**
 * Recorded location of a worker.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Maps Coordinate API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class LocationRecord extends GenericJson {

  /**
   * The collection time in milliseconds since the epoch.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @JsonString
  private Long collectionTime;

  /**
   * The location accuracy in meters. This is the radius of a 95% confidence interval around the
   * location measurement.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Double confidenceRadius;

  /**
   * Identifies this object as a location.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * Latitude.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Double latitude;

  /**
   * Longitude.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Double longitude;

  /**
   * The collection time in milliseconds since the epoch.
   * The value returned may be {@code null}.
   */
  public Long getCollectionTime() {
    return collectionTime;
  }

  /**
   * The collection time in milliseconds since the epoch.
   * The value set may be {@code null}.
   */
  public LocationRecord setCollectionTime(Long collectionTime) {
    this.collectionTime = collectionTime;
    return this;
  }

  /**
   * The location accuracy in meters. This is the radius of a 95% confidence interval around the
   * location measurement.
   * The value returned may be {@code null}.
   */
  public Double getConfidenceRadius() {
    return confidenceRadius;
  }

  /**
   * The location accuracy in meters. This is the radius of a 95% confidence interval around the
   * location measurement.
   * The value set may be {@code null}.
   */
  public LocationRecord setConfidenceRadius(Double confidenceRadius) {
    this.confidenceRadius = confidenceRadius;
    return this;
  }

  /**
   * Identifies this object as a location.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Identifies this object as a location.
   * The value set may be {@code null}.
   */
  public LocationRecord setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Latitude.
   * The value returned may be {@code null}.
   */
  public Double getLatitude() {
    return latitude;
  }

  /**
   * Latitude.
   * The value set may be {@code null}.
   */
  public LocationRecord setLatitude(Double latitude) {
    this.latitude = latitude;
    return this;
  }

  /**
   * Longitude.
   * The value returned may be {@code null}.
   */
  public Double getLongitude() {
    return longitude;
  }

  /**
   * Longitude.
   * The value set may be {@code null}.
   */
  public LocationRecord setLongitude(Double longitude) {
    this.longitude = longitude;
    return this;
  }

}
